<?php
/*
Copyright (C) 2007 Stephane Graber <stgraber@ubuntu.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

function qatracker_checkpostvalue() {
	$data=$_POST;
	$data['isot_comment']=htmlentities($data['isot_comment'],ENT_QUOTES,"UTF-8");
	$data['isot_bug']=array();
	$count=0;
	if ($data['isot_bugnumber']) {
		foreach ($data['isot_bugnumber'] as $bug) {
			if ($data['isot_serious'] && in_array($count,$data['isot_serious']))
				$serious=1;
			else
				$serious=0;
			if (is_numeric($bug))
				array_push_associative($data['isot_bug'], array($bug => $serious));
			elseif ($bug == "")
				$data['isot_error'].="";
			else
				$data['isot_error'].="<font color=\"red\">Invalid value (".htmlentities($bug,ENT_QUOTES,"UTF-8").")</font><br />";
			$count++;
		}
	}
	if ((!is_numeric($data['isot_result'])) && ($data['isot_valid'] || $data['isot_addbug'])) {
		$data['isot_error'].="<font color=\"red\">You must select a result</font><br />";
	}
	if (($data['isot_result'] == 0) && (count($data['isot_bug']) == 0) &&  ($_SERVER['REQUEST_METHOD'] === 'POST'))
		$data['isot_error'].="<font color=\"red\">To mark a test as failed, you need to provide a bug number</font><br />";
	return $data;
}

function qatracker_getbugslist($buildID, $testcaseID, $resultID) {
	global $base_url;
	$where="WHERE qatracker_result.status='0' ";
	if ($buildID != 0) {
		$where.="AND qatracker_result.buildid='".$buildID."' ";
	}
	if ($testcaseID != 0) {
		$where.="AND qatracker_result.testcaseid='".$testcaseID."' ";
	}
	if ($resultID != 0) {
		$where.="AND qatracker_result.id='".$resultID."' ";
	}
	$result=db_query("SELECT qatracker_bug.bugnumber, max(qatracker_bug.bugimportance) as importance, count(qatracker_bug.bugnumber) as dupe FROM qatracker_bug LEFT JOIN qatracker_result ON qatracker_result.id=qatracker_bug.resultid $where GROUP BY qatracker_bug.bugnumber ORDER BY importance DESC,dupe DESC,bugnumber ASC");
	while ($bug = db_fetch_object($result)) {
		if ($bug->importance == 1)
			$file="badbug";
		else
			$file="bug";
		if ($bug->dupe >= 1)
			$size="21px";
		if ($bug->dupe >= 2)
			$size="23px";
		if ($bug->dupe >= 5)
			$size="24px";
		if ($testcaseID != 0 || $resultID != 0)
			$size="24px";
		$content.=qawebsite_bugballoon($bug->bugnumber,"<img style=\"margin-top:-6px;width:$size;height:$size\" src=\"$base_url/modules/qawebsite/images/$file.png\" alt=\"bug #".$bug->bugnumber."\" />","left");
	}
	return $content;
}

function qatracker_getpath($args) {
	global $site;

	if (!is_array($args))
		return;
	if (count($args) < 1)
		$args[0]="build";

	foreach($args as $arg)
		$arg=strip_tags($arg);

	if ($args[0] == "admin")
		$path="<span class=\"qatrackerpath\" style=\"background-color:#ffff99;\"><b>You are here : </b><a href=\"/qatracker/\">QA Tracker</a>";
	else
		$path="<span class=\"qatrackerpath\" style=\"background-color:#f4f4f4;\"><b>You are here : </b><a href=\"/qatracker/\">QA Tracker</a>";
	switch ($args[0]) {
		case "build":
			if (count($args) > 1)
				$path.=" -> <a href=\"/qatracker/build/".$args[1]."\">".$args[1]."</a>";
			else
				$path.=" -> <a href=\"/qatracker/build/".db_result(db_query("SELECT link FROM qatracker_filter WHERE filter='".db_escape_string($site->getSetting("default_product"))."'"))."\">".db_result(db_query("SELECT link FROM qatracker_filter WHERE filter='".db_escape_string($site->getSetting("default_product"))."'"))."</a>";
			if (count($args) > 2)
				$path.=" -> <a href=\"/qatracker/build/".$args[1]."/".$args[2]."\">".$args[2]."</a>";
		break;
		case "test":
			if (count($args) < 2)
				return;
			$path.=" -> <a href=\"/qatracker/test/".$args[1]."\">Test list</a>";
		break;
		case "result":
			if (count($args) < 3)
				return;
			$path.=" -> <a href=\"/qatracker/test/".$args[1]."\">Test list</a> -> <a href=\"/qatracker/result/".$args[1]."/".$args[2]."\">Result list</a>";
		break;
		case "info":
			if (count($args) < 2)
				return;
			$path.=" -> <a href=\"/qatracker/info/".$args[1]."\">Build information</a>";
		break;
		case "user":
			if (count($args) < 2)
				return;
			switch($args[1]) {
				case "subscription":
					$path.=" -> <a href=\"/qatracker/user/subscription\">My subscriptions</a>";
				break;
			}
		break;
		case "subscriptions":
			$path.=" -> <a href=\"/qatracker/subscriptions\">Subscriptions summary</a>";
		break;
		case "testcases":
			$path.=" -> <a href=\"/qatracker/testcases\">Testcase coverage</a>";
		break;
		case "admin":
			if (count($args) < 2)
				return;
			switch($args[1]) {
				case "edit":
					if (count($args) < 4)
						return;
					$path.=" -> <a href=\"/qatracker/test/".$args[2]."\">Test list</a> -> <a href=\"/qatracker/result/".$args[2]."/".$args[3]."\">Result list</a> -> <a href=\"/qatracker/admin/edit/".$args[2]."/".$args[3]."/".$args[4]."\">Edit result</a>";
				break;
				case "addbuild":
					$path.=" -> <a href=\"/qatracker/admin/addbuild\">Add build set (manual)</a>";
				break;
				case "mailing":
					$path.=" -> <a href=\"/qatracker/admin/mailing\">Mass Mailing</a>";
				break;
				case "milestone":
					$path.=" -> <a href=\"/qatracker/admin/milestone\">Milestone management</a>";
					if (count($args) > 2)
						$path.=" -> <a href=\"/qatracker/admin/milestone/".$args[2]."\">Milestone detail</a>";
				break;
			}
		break;
		case "report":
			$path.=" -> <a href=\"/qatracker/report\">Report</a>";
		break;
		case "archive":
			$path.=" -> <a href=\"/qatracker/archive\">Archive</a>";
			if (count($args) > 1)
				$path.=" -> <a href=\"/qatracker/archive/".$args[1]."\">".$args[1]."</a>";
			else
				$path.=" -> <a href=\"/qatracker/archive/".$site->getSetting('default_product')."\">".$site->getSetting('default_product')."</a>";
		break;
	}
	$path.="</span>";
	return $path;
}

function qatracker_getbuildstat($buildID,$archive=0) {
	$total=db_query("SELECT count(title) from qatracker_testcase LEFT JOIN qatracker_build ON qatracker_build.productid=qatracker_testcase.productid WHERE qatracker_build.id='$buildID' AND qatracker_testcase.status='0' AND qatracker_testcase.status='0'");
	$total=db_result($total);
	$done=db_query("SELECT count(DISTINCT testcaseID) from qatracker_result LEFT JOIN qatracker_testcase ON qatracker_testcase.id=qatracker_result.testcaseid WHERE qatracker_result.buildid='".$buildID."' AND qatracker_result.status='0' AND qatracker_result.result != '2' AND qatracker_testcase.status='0'");
	$done=db_result($done);
	$donet=db_query("SELECT count(DISTINCT testcaseID) from qatracker_result LEFT JOIN qatracker_testcase ON qatracker_testcase.id=qatracker_result.testcaseid WHERE qatracker_result.buildid='".$buildID."' AND qatracker_result.result != '2' AND qatracker_result.status='0'");
	$donet=db_result($donet);
	$reports=db_query("SELECT count(id) from qatracker_result WHERE buildid='".$buildID."' AND status='0'");
	$reports=db_result($reports);
	$fail=db_query("SELECT count(id) from qatracker_result WHERE buildid='".$buildID."' AND status='0' AND result='0'");
	$fail=db_result($fail);
	if ($archive == 1)
		$total=$done;
	if ($fail != 0)
		$fail="<span style=\"font-weight:bold; color:#641500;\">($fail)</span>";
	else
		$fail="";
	if ($archive == "1")
		return "$donet $fail";
	if ($done == $total)
		return "<span style=\"font-weight:bold; color:#006400;\">$done/$total</span> $fail";
	elseif ($reports == 0)
		return "<span style=\"color:#000a8a;\">$done/$total</span> $fail";
	else
		return "$done/$total $fail";
}

function qatracker_getbuildreportstat($productid, $isoid=0) {
	if ($isoid != 0)
		$where="AND qatracker_result.buildid='$isoid'";
	$total=db_query("SELECT count(title) from qatracker_testcase WHERE productid='$productid' ");
	$total=db_result($total);
	$done=db_query("SELECT count(DISTINCT qatracker_result.testcaseID) from qatracker_result LEFT JOIN qatracker_testcase ON qatracker_testcase.id=qatracker_result.testcaseid WHERE qatracker_testcase.productid='$productid' $where");
	$done=db_result($done);
	return "$done ($total)";
}

function qatracker_getbugreportstat($productid, $buildid=0) {
	if ($buildid != 0)
		$where="AND qatracker_result.buildid='$buildid'";
	$total=db_query("SELECT count(DISTINCT qatracker_bug.bugnumber) from qatracker_bug LEFT JOIN qatracker_result ON qatracker_result.id=qatracker_bug.resultid LEFT JOIN qatracker_build ON qatracker_build.id=qatracker_result.buildid WHERE qatracker_build.productid='$productid' $where");
	$total=db_result($total);
	$critical=db_query("SELECT count(DISTINCT qatracker_bug.bugnumber) from qatracker_bug LEFT JOIN qatracker_result ON qatracker_result.id=qatracker_bug.resultid LEFT JOIN qatracker_build ON qatracker_build.id=qatracker_result.buildid WHERE qatracker_build.productid='$productid' AND qatracker_bug.bugimportance='1' $where");
	$critical=db_result($critical);
	if(!$critical)
		$critical=0;
	return "$total ($critical)";
}

function qatracker_getresultsnumber($buildID, $testcaseID) {
	$fail="";
	$total=db_query("SELECT count(id) from qatracker_result WHERE buildid='".$buildID."' AND testcaseid='".$testcaseID."' AND status='0'");
	$total=db_result($total);
	if ($total == 0) {
		$total="None";
	}
	else {
		$finished=db_query("SELECT count(id) from qatracker_result WHERE buildid='".$buildID."' AND testcaseid='".$testcaseID."' AND status='0' AND result != '2'");
		$finished=db_result($finished);    
		if ($finished == 0) {
			$total = "Started";
		}
		else {
			$total = $finished;
			$fail=db_query("SELECT count(id) from qatracker_result WHERE buildid='".$buildID."' AND testcaseid='".$testcaseID."' AND status='0' AND result='0'");
			$fail=db_result($fail);

			if ($fail != 0)
				$fail="<span style=\"font-weight:bold; color:#641500;\">($fail)</span>";
			else
				$fail="";
		}
	}
	return "$total $fail";
}

function qatracker_getmilestonestatus($status) {
	switch($status) {
		case "0" :
			return "testing";
		break;
		case "1" :
			return "released";
		break;
		case "2" :
			return "hidden";
		break;
	}
}

?>
